
#include "DcDialog.Ch"
#include "DcPick.Ch"

FUNCTION Mvp826()

  LOCAL GetList := {}, GetOptions, cAlias, aListField, aPickField, oBrowse, oDialog, oStatic, oPickList, aStruct

  SELECT DebtMst
  nRecords   := 0
  DbGoTop()
  DO WHILE !Eof()
	 nRecords++
	 DbSkip()
  ENDDO
  DbGoTop()

  aStruct    := dbStruct()
  cAlias     := 'DebtMst'
  aListField := Array(FCount())
  AFields(aListField)
  aPickField := { aListField[4], aListField[35], aListField[36], aListField[37], aListField[38], aListField[39], aListField[34], aListField[60] }  // Display defaults

  ADel(aListField,4)                                                                                                                               // Remove default selections from list
  ADel(aListField,34)
  ADel(aListField,33)
  ADel(aListField,33)
  ADel(aListField,33)
  ADel(aListField,33)
  ADel(aListField,28)
  ADel(aListField,53)

  ASize(aListField,Len(aListField)-8)                                                                                                              // Correct size

  @  2.00, 3.00 DCPICKLIST aPickField         LIST aListField ;
                CAPTION "Available Fields", "Selected Fields"                         SIZE 45,12 ;
                COPYITEMS ;
                IMMEDIATE ;
                OBJECT oPickList

  @  2.00,50.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX                              SIZE 49,12 ;
                OBJECT oStatic ;
                RESIZE DCGUI_RESIZE_RESIZEONLY ;
                EVAL {|o| o:resize := {|a,b,o,x| x := o:childList(), ;
                                                 IIF(!Empty(x),x[1]:setSize({o:currentSize()[1]-6,o:currentSize()[2]-6}),Nil)} }

  @ 14.50, 3.00 DCPUSHBUTTON                  CAPTION 'Sort'                          SIZE  6, 1 ;
                ACTION {|| ASort(aListField),oPickList:setData(aListField,aPickField) }

  @ 14.50,23.00 DCPUSHBUTTON                  CAPTION 'Sort'                          SIZE  6, 1 ;
                ACTION {|| ASort(aPickField),oPickList:setData(aListField,aPickField) }

  @ 14.75,70.00 DCSAY {|| LTRIM(TRANSFORM(nRecords,"999,999")) + "  Records Ready for Export."}                                                           COLOR GRA_CLR_DARKRED ;
                HIDE {|| nRecords == 0 }

  @ DCGUI_ROW,  DCGUI_COL + 20 DCPUSHBUTTON   CAPTION '5'                             SIZE  2, 1 ;
                FONT '12.Marlett' ;
                ACTION {|| NavPickList(oPickList,@aListField,@aPickField,1) }

  @ DCGUI_ROW,  DCGUI_COL DCPUSHBUTTON        CAPTION '6'                             SIZE  2, 1 ;
                FONT '12.Marlett' ;
                ACTION {|| NavPickList(oPickList,@aListField,@aPickField,2) }

  @ 14.50,40.00 DCPUSHBUTTON                  CAPTION 'Browse'                        SIZE  8, 1 ;
                ACTION {|| Browse826(cAlias,oDialog,@oBrowse,@aPickField,oStatic) }

  @ DCGUI_ROW,  DCGUI_COL + 10 DCPUSHBUTTON   CAPTION 'Export'                        SIZE  8, 1 ;
					 WHEN {|| nRecords > 0 } ;
                ACTION {|| ExportCollect(aStruct,aPickField) }

  @ DCGUI_ROW,  DCGUI_COL + 10 DCPUSHBUTTON   CAPTION 'Filter'                        SIZE  8, 1 ;
                ACTION {|| Filter826( @oBrowse ) }

  DCGETOPTIONS ;
    RESIZE ;
    TABSTOP ;
    SOURCEFILE __FILEPATH__

  DCREAD GUI ;
         FIT ;
         MODAL ;
         PARENT @oDialog ;
         OPTIONS GetOptions ;
         TITLE "Export Collections Data to Excel Format"


RETURN Nil

*---

STATIC FUNCTION NavPickList( oPickList, aListField, aPickField, nMode )

  LOCAL i, oListBox := oPickList:rightListBox, aSelected, aMove[0], nCount

  aSelected := oListBox:getData()

  IF Empty(aSelected)
    RETURN Nil
  ELSEIF nMode == 1 .AND. aSelected[1] == 1
    RETURN Nil
  ELSEIF nMode == 2 .AND. ATail(aSelected) == Len(aPickField)
    RETURN Nil
  ENDIF

  FOR i := Len(aSelected) TO 1 STEP -1
    AAdd(aMove,aPickField[aSelected[i]])
    ARemove(aPickField,aSelected[i])
    IF nMode == 1
      aSelected[i]--
    ELSE
      aSelected[i]++
    ENDIF
  NEXT

  nCount := Len(aMove)
  FOR i := 1 TO Len(aSelected)
    AAdd(aPickField,nil)
    AIns(aPickField,aSelected[i],aMove[nCount--])
  NEXT

  oPickList:setData(aListField,aPickField)

  oListBox:setData(aSelected)

RETURN Nil

*---

STATIC FUNCTION Browse826 ( cAlias, oDialog, oBrowse, aPickField, oStatic )

  LOCAL GetList := {}, i, aChildList, GetOptions

  IF Valtype(oBrowse) == 'O'
    oBrowse:Destroy()
  ENDIF

  oBrowse := Nil

  IF Empty(aPickField)
    RETURN Nil
  ENDIF

  @  3.00, 3.00 DCBROWSE oBrowse  DATA cAlias                   SIZE oStatic:currentSize()[1]-6, oStatic:currentSize()[2]-6           PARENT oStatic ;
                PIXEL ;
                PRESENTATION DC_BrowPres()



  SELECT DebtMst
  FOR i := 1 TO Len(aPickField)
    DCBROWSECOL DATA &('{|| DebtMst->' + aPickField[i] + '}')   HEADER aPickField[i]                                                  PARENT oBrowse
  NEXT

  DCREAD GUI ;
     EXIT ;
     MODAL ;
     PARENT oDialog

RETURN Nil

*---

STATIC FUNCTION ExportCollect( aStruct, aPickField )

  LOCAL i, nFound, cExcelFile, aExport[0], cFilter := DebtMst->(dbFilter())

  FOR i := 1 TO Len(aPickField)
    nFound := AScan(aStruct,{|a| a[1] == aPickField[i]})
    IF nFound > 0
      AAdd( aExport, aStruct[nFound,1] )
    ENDIF
  NEXT

  cExcelFile := '\_Psst\Mv\' + DtoS(Date()) + '.Xls'

  IF DC_WorkArea2Excel(cExcelFile, 1, .f., .t., aExport, .t.)
    DcMsgBox 'Collections Data Exported to ' + cExcelFile
	 DC_SpawnUrl(cExcelFile)
  ENDIF

  IF !Empty(cFilter)
	 SELECT DebtMst
    SET FILTER TO
  ENDIF

RETURN Nil

*---

STATIC FUNCTION Filter826( oBrowse )

  LOCAL cFilter := DebtMst->(dbFilter())

  cFilter       := DebtMst->(DC_QueryBuild(cFilter))

  IF !Empty(cFilter)
    SET FILTER TO &(cFilter)
    DC_DbGoTop()
    IF Valtype(oBrowse) == 'O'
      oBrowse:refreshAll()
    ENDIF
  ENDIF

RETURN Nil
